package com.telr

import android.content.Intent
import android.os.Bundle
import android.os.Parcelable
import android.view.View
import android.widget.EditText
import android.widget.TextView
import androidx.annotation.Keep
import androidx.appcompat.app.AppCompatActivity
import com.telr.MainActivity
import com.telr.mobile.sdk.activity.WebviewActivity
import com.telr.mobile.sdk.entity.request.payment.*
import com.telr.mobile.sdk.entity.response.payment.MobileResponse
import com.telr.mobile.sdk.entity.response.status.StatusResponse
import com.telr.mobile.sdk.entity.response.status.StatusResponseFailed
import java.math.BigInteger
import java.util.*

@Keep
class MainActivity : AppCompatActivity() {
    var text_language: EditText? = null
    var text_currency: EditText? = null
    private var amount = "1" // Just for testing

    //let EMAIL:String = "girish.spryox@gmail.com" //"?????????"  // TODO fill email
    public override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        text_language = findViewById(R.id.text_language)
        text_currency = findViewById(R.id.text_currency)

//        try{
//            Log.e("Pref:",TelrSharedPreference.getInstance(MainActivity.this).getDataFromPreference("Code"));
//        }catch (NullPointerException ne){
//            ne.printStackTrace();
//        }
    }

    fun sendMessage(view: View?) {
        val intent = Intent(this@MainActivity, WebviewActivity::class.java)

//        intent.addFlags(Intent.FLAG_ACTIVITY_BROUGHT_TO_FRONT);
//         intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        val editText = findViewById<View>(R.id.text_amount) as EditText
        amount = editText.text.toString()
        intent.putExtra(WebviewActivity.EXTRA_MESSAGE, mobileRequest)
        intent.putExtra(WebviewActivity.SUCCESS_ACTIVTY_CLASS_NAME, "com.telr.SuccessTransationActivity")
        intent.putExtra(WebviewActivity.FAILED_ACTIVTY_CLASS_NAME, "com.telr.FailedTransationActivity")
        intent.putExtra(WebviewActivity.IS_SECURITY_ENABLED, isSecurityEnabled)
        //        startActivity(intent);
        startActivityForResult(intent, REQUEST_CODE)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, intent: Intent?) {
        super.onActivityResult(requestCode, resultCode, intent)
        if (requestCode == REQUEST_CODE &&
                resultCode == RESULT_OK) {
            val `object`: Any = intent!!.getParcelableExtra(WebviewActivity.PAYMENT_RESPONSE)
            val paymentMethod = intent.getStringExtra("auth")
            if (paymentMethod.equals("yes", ignoreCase = true)) {
                val status = intent.getParcelableExtra<Parcelable>(WebviewActivity.PAYMENT_RESPONSE) as MobileResponse

//                TextView textView = (TextView)findViewById(R.id.text_payment_result);
//                TextView txt_code=(TextView)findViewById(R.id.txt_code);
//                txt_code.setText("Code : "+intent.getStringExtra("Code"));
//                textView.setText(textView.getText() +" : " + status.getTrace());
                //  Log.e("CODEZZZ",":"+ TelrSharedPreference.getInstance(this).getDataFromPreference("Code"));
                if (status.getAuth() != null) {
                    status.getAuth().getStatus() // Authorisation status. A indicates an authorised transaction. H also indicates an authorised transaction, but where the transaction has been placed on hold. Any other value indicates that the request could not be processed.
                    status.getAuth().getAvs() /* Result of the AVS check:
                                            Y = AVS matched OK
                                            P = Partial match (for example, post-code only)
                                            N = AVS not matched
                                            X = AVS not checked
                                            E = Error, unable to check AVS */
                    status.getAuth().getCode() // If the transaction was authorised, this contains the authorisation code from the card issuer. Otherwise it contains a code indicating why the transaction could not be processed.
                    status.getAuth().getMessage() // The authorisation or processing error message.
                    status.getAuth().getCa_valid()
                    status.getAuth().getCardcode() // Code to indicate the card type used in the transaction. See the code list at the end of the document for a list of card codes.
                    status.getAuth().getCardlast4() // The last 4 digits of the card number used in the transaction. This is supplied for all payment types (including the Hosted Payment Page method) except for PayPal.
                    status.getAuth().getCvv() /* Result of the CVV check:
                                           Y = CVV matched OK
                                           N = CVV not matched
                                           X = CVV not checked
                                           E = Error, unable to check CVV */
                    status.getAuth().getTranref() //The payment gateway transaction reference allocated to this request.
                    status.getAuth().getCard().getFirst6() // The first 6 digits of the card number used in the transaction, only for version 2 is submitted in Tran -> Version
                    status.getAuth().getCard().getCountry()
                    status.getAuth().getCard().getExpiry().getMonth()
                    status.getAuth().getCard().getExpiry().getYear()
                }
            } else if (paymentMethod.equals("no", ignoreCase = true)) {
                val status = intent.getParcelableExtra<Parcelable>(WebviewActivity.PAYMENT_RESPONSE) as StatusResponse

//                TextView textView = (TextView) findViewById(R.id.text_payment_result);
//                TextView txt_code = (TextView) findViewById(R.id.txt_code);
//                txt_code.setText("Code : " + intent.getStringExtra("Code"));
//                textView.setText(textView.getText() + " : " + status.getTrace());
                //  Log.e("CODEZZZ",":"+ TelrSharedPreference.getInstance(this).getDataFromPreference("Code"));
                if (status.getAuth() != null) {
                    status.getAuth().getStatus() // Authorisation status. A indicates an authorised transaction. H also indicates an authorised transaction, but where the transaction has been placed on hold. Any other value indicates that the request could not be processed.
                    status.getAuth().getAvs() /* Result of the AVS check:
                                            Y = AVS matched OK
                                            P = Partial match (for example, post-code only)
                                            N = AVS not matched
                                            X = AVS not checked
                                            E = Error, unable to check AVS */
                    status.getAuth().getCode() // If the transaction was authorised, this contains the authorisation code from the card issuer. Otherwise it contains a code indicating why the transaction could not be processed.
                    status.getAuth().getMessage() // The authorisation or processing error message.
                    status.getAuth().getCa_valid()
                    status.getAuth().getCardcode() // Code to indicate the card type used in the transaction. See the code list at the end of the document for a list of card codes.
                    status.getAuth().getCardlast4() // The last 4 digits of the card number used in the transaction. This is supplied for all payment types (including the Hosted Payment Page method) except for PayPal.
                    status.getAuth().getCvv() /* Result of the CVV check:
                                           Y = CVV matched OK
                                           N = CVV not matched
                                           X = CVV not checked
                                           E = Error, unable to check CVV */
                    status.getAuth().getTranref() //The payment gateway transaction reference allocated to this request.
                    status.getAuth().getCard().getFirst6() // The first 6 digits of the card number used in the transaction, only for version 2 is submitted in Tran -> Version
                    status.getAuth().getCard().getCountry()
                    status.getAuth().getCard().getExpiry().getMonth()
                    status.getAuth().getCard().getExpiry().getYear()
                }
            } else if (paymentMethod.equals("cancel", ignoreCase = true)) {
                if (`object` is StatusResponseFailed) {
                    val status = `object`
                    val txt_code = findViewById<View>(R.id.txt_code) as TextView
                    // txt_code.setText(" "+status.getTrace());
                    if (status.getAuth() != null) {
                        status.getAuth().getStatus() // Authorisation status. A indicates an authorised transaction. H also indicates an authorised transaction, but where the transaction has been placed on hold. Any other value indicates that the request could not be processed.
                        status.getAuth().getAvs() /* Result of the AVS check:
                                            Y = AVS matched OK
                                            P = Partial match (for example, post-code only)
                                            N = AVS not matched
                                            X = AVS not checked
                                            E = Error, unable to check AVS */
                        status.getAuth().getCode() // If the transaction was authorised, this contains the authorisation code from the card issuer. Otherwise it contains a code indicating why the transaction could not be processed.
                        status.getAuth().getMessage() // The authorisation or processing error message.
                        /**
                         * Commented by Divya on 06/08/2020.
                         */
                        status.getAuth().getCa_valid() // commented Divya
                        status.getAuth().getCardfirst6()
                        //  status.getAuth().getCard().getExpiry();
                        status.getAuth().getCardcode() // Code to indicate the card type used in the transaction. See the code list at the end of the document for a list of card codes.
                        status.getAuth().getCardlast4() // The last 4 digits of the card number used in the transaction. This is supplied for all payment types (including the Hosted Payment Page method) except for PayPal.
                        status.getAuth().getCvv() /* Result of the CVV check:
                                           Y = CVV matched OK
                                           N = CVV not matched
                                           X = CVV not checked
                                           E = Error, unable to check CVV */
                        status.getAuth().getTranref() //The payment gateway transaction reference allocated to this request.
                        status.getAuth().getAvs() /* Result of the AVS check:
                                           Y = AVS matched OK
                                           P = Partial match (for example, post-code only)
                                           N = AVS not matched
                                           X = AVS not checked
                                           E = Error, unable to check AVS */


//                status.getAuth().getCard().getCountry(); // /
//
//                status.getAuth().getCard().getExpiry().getMonth();
//                status.getAuth().getCard().getExpiry().getYear();
                    }
                } else if (`object` is String) {
                    val errorMessage = `object`
                }
            }
        }
    }

    // Store ID
    // Authentication Key : The Authentication Key will be supplied by Telr as part of the Mobile API setup process after you request that this integration type is enabled for your account. This should not be stored permanently within the App.
    val mobileRequest: com // Application installation ID
    // Application name
    // Application user ID : Your reference for the customer/user that is running the App. This should relate to their account within your systems.
    // Application version
    //1                        // Test mode : Test mode of zero indicates a live transaction. If this is set to any other value the transaction will be treated as a test. /* Transaction type
//    'auth'   : Seek authorisation from the card issuer for the amount specified. If authorised, the funds will be reserved but will not be debited until such time as a corresponding capture command is made. This is sometimes known as pre-authorisation.
//    'sale'   : Immediate purchase request. This has the same effect as would be had by performing an auth transaction followed by a capture transaction for the full amount. No additional capture stage is required.
//    'verify' : Confirm that the card details given are valid. No funds are reserved or taken from the card.
//    */ // Transaction class only 'paypage' is allowed on mobile, which means 'use the hosted payment page to capture and process the card details'
    //// Transaction cart ID : An example use of the cart ID field would be your own transaction or order reference.
    // Transaction description
    // Transaction currency : Currency must be sent as a 3 character ISO code. A list of currency codes can be found at the end of this document. For voids or refunds, this must match the currency of the original transaction.
    // Transaction amount : The transaction amount must be sent in major units, for example 9 dollars 50 cents must be sent as 9.50 not 950. There must be no currency symbol, and no thousands separators. Thedecimal part must be separated using a dot.
    //        tran.setRef("040025801054");                                // (Optinal) Previous transaction reference : The previous transaction reference is required for any continuous authority transaction. It must contain the reference that was supplied in the response for the original transaction.

    //040023303844  //030023738912
    // tran.setFirstref("030023738912");             // (Optinal) Previous user transaction detail reference : The previous transaction reference is required for any continuous authority transaction. It must contain the reference that was supplied in the response for the original transaction.
    // City : the minimum required details for a transaction to be processed
    // Country : Country must be sent as a 2 character ISO code. A list of country codes can be found at the end of this document. the minimum required details for a transaction to be processed
    // Region
    // Street address – line 1: the minimum required details for a transaction to be processed
    //address.setLine2("SIT G=Towe");               // (Optinal)
    //address.setLine3("SIT G=Towe");               // (Optinal)
    //address.setZip("SIT G=Towe");                 // (Optinal)
    // Forename : the minimum required details for a transaction to be processed
    // Surname : the minimum required details for a transaction to be processed
    // Title
    //girish.spryox@gmail.com//stackfortytwo@gmail.com : the minimum required details for a transaction to be processed.
    .telr.mobile.sdk.entity.request.payment.MobileRequest
    get()
    {
        val mobile = MobileRequest()
        mobile.setStore(STORE_ID) // Store ID
        mobile.setKey(KEY) // Authentication Key : The Authentication Key will be supplied by Telr as part of the Mobile API setup process after you request that this integration type is enabled for your account. This should not be stored permanently within the App.
        val app = App()
        app.setId("123456789") // Application installation ID
        app.setName("TelrSDK") // Application name
        app.setUser("123456") // Application user ID : Your reference for the customer/user that is running the App. This should relate to their account within your systems.
        app.setVersion("0.0.1") // Application version
        app.setSdk("123")
        mobile.setApp(app)
        val tran = Tran()
        tran.setTest("1") //1                        // Test mode : Test mode of zero indicates a live transaction. If this is set to any other value the transaction will be treated as a test.
        tran.setType("auth") /* Transaction type
                                                            'auth'   : Seek authorisation from the card issuer for the amount specified. If authorised, the funds will be reserved but will not be debited until such time as a corresponding capture command is made. This is sometimes known as pre-authorisation.
                                                            'sale'   : Immediate purchase request. This has the same effect as would be had by performing an auth transaction followed by a capture transaction for the full amount. No additional capture stage is required.
                                                            'verify' : Confirm that the card details given are valid. No funds are reserved or taken from the card.
                                                        */
        tran.setClazz("paypage") // Transaction class only 'paypage' is allowed on mobile, which means 'use the hosted payment page to capture and process the card details'
        tran.setCartid(BigInteger(128, Random()).toString()) //// Transaction cart ID : An example use of the cart ID field would be your own transaction or order reference.
        tran.setDescription("Test Mobile API") // Transaction description
        tran.setLanguage(text_language!!.text.toString())
        tran.setCurrency(text_currency!!.text.toString()) // Transaction currency : Currency must be sent as a 3 character ISO code. A list of currency codes can be found at the end of this document. For voids or refunds, this must match the currency of the original transaction.
        tran.setAmount(amount) // Transaction amount : The transaction amount must be sent in major units, for example 9 dollars 50 cents must be sent as 9.50 not 950. There must be no currency symbol, and no thousands separators. Thedecimal part must be separated using a dot.
        //        tran.setRef("040025801054");                                // (Optinal) Previous transaction reference : The previous transaction reference is required for any continuous authority transaction. It must contain the reference that was supplied in the response for the original transaction.

        //040023303844  //030023738912
        // tran.setFirstref("030023738912");             // (Optinal) Previous user transaction detail reference : The previous transaction reference is required for any continuous authority transaction. It must contain the reference that was supplied in the response for the original transaction.
        mobile.setTran(tran)
        val billing = Billing()
        val address = Address()
        address.setCity("Dubai") // City : the minimum required details for a transaction to be processed
        address.setCountry("AE") // Country : Country must be sent as a 2 character ISO code. A list of country codes can be found at the end of this document. the minimum required details for a transaction to be processed
        address.setRegion("Dubai") // Region
        address.setLine1("SIT GTower") // Street address – line 1: the minimum required details for a transaction to be processed
        //address.setLine2("SIT G=Towe");               // (Optinal)
        //address.setLine3("SIT G=Towe");               // (Optinal)
        //address.setZip("SIT G=Towe");                 // (Optinal)
        billing.setAddress(address)
        val name = Name()
        name.setFirst("Divya") // Forename : the minimum required details for a transaction to be processed
        name.setLast("Thampi") // Surname : the minimum required details for a transaction to be processed
        name.setTitle("Mrs") // Title
        billing.setName(name)
        billing.setEmail("successful.payment@tabby.ai") //girish.spryox@gmail.com//stackfortytwo@gmail.com : the minimum required details for a transaction to be processed.
        billing.setPhone("500000001")
        mobile.setBilling(billing)
        return mobile
    }

    companion object {
        const val KEY = "pQ6nP-7rHt@5WRFv" //"kCB5C#cg9MK@Njqp";//"pQ6nP-7rHt@5WRFv";//"s66Mx#BMN5-djBWj"; //"BwxtF~dq9L#xgWZb";//pQ6nP-7rHt@5WRFv        // TODO: Insert your Key here
        const val STORE_ID = "15996" //"20880";// "15996";//"18503";//"21941";   //15996           // TODO: Insert your Store ID here
        const val isSecurityEnabled = true // Mark false to test on simulator, True to test on actual device and Production
        const val REQUEST_CODE = 100
    }
}